"""
Solving problems with Dynamic Programming

Copyright 2020, University of Freiburg

Philipp Schneider <philipp.schneider@cs.uni-freiburg.de>
"""

import sys

sys.setrecursionlimit(10000)


def has_equal_partition(array):
    '''
        Returns True if and only if there is a partition of
        the integers in the input array that have equal sum
        of weights.

        Parameter:
            array - contains positive integers

        Returns:
            a boolean value representing whether this array
            can be partitioned into sets with equal sum
    '''


def no_consecutive_ones(n):
    '''
        Returns the number of n-digit binary strings
        without consecutive ones

        Parameter:
            n - positive integer

        Returns:
            positive integer
    '''


def read_array(filename):
    '''
        reads an integer array from a file

        Parameter:
            filename - name of file

        Returns:
            array of integers in the file
    '''
    with open(filename) as input:
        strings = input.read().split(' ')
        array = [int(strings[i]) for i in range(len(strings))]
    return array
